% Generate the signal todya based on the last shock
    
if s(j-1) == 1;
     s(j) = 0;   % initialize
     if rand < PIs(1,1)
         s(j) = 1;
     end
 else
     s(j) = 0;   % initialize
     if rand < PIs(2,1)
         s(j) = 1;
     end
end

% Generate the shock today

if s(j) == 1
     epshat(j) = (Support(1,1)-Xstd)/Xstd;
     Qhat(j)   = Qhat(j-1) + epshat(j)*Xstd;
else
      epshat(j)=(Support(2,1)-Xstd)/Xstd;
      Qhat(j)   = Qhat(j-1) + epshat(j)*Xstd;
end

% Generate expected shocks in periods when we have expected signals
% conditioned on s(t+v)    
%
if s(j) == 0
    index = 2;
else
    index = 1;
end
%
for tt = j+1:j+T
    PIprime = (PIs)^(tt-(j));
    epshat(tt) =(Support(1,1)-Xstd)/Xstd*(PIprime(index,1)) +(Support(2,1)-Xstd)/Xstd*(PIprime(index,2));  
    Qhat(tt) = Qhat(tt-1) + epshat(tt)*Xstd;
end





        
    