if epshat(j+v-1)==(Support(1,1)-Xstd)/Xstd;
         if rand < PIsp(1,1)
            epshat(j+v) = (Support(1,1)-Xstd)/Xstd; %generate the value of the shock based on the true Markov chain.
         else
            epshat(j+v) = (Support(2,1)-Xstd)/Xstd;
         end
elseif epshat(j+v-1)==(Support(2,1)-Xstd)/Xstd;
         if rand < PIsp(2,1)
            epshat(j+v) = (Support(1,1)-Xstd)/Xstd;
         else
            epshat(j+v) = (Support(2,1)-Xstd)/Xstd;
         end
end
%In every period we look at the current shock epsilon t and we get a
%signal - but we get a signal for two periods - tommorow (a revised signal)
%and two days from now (or until v periods).
    if  epshat(j+v)==(Support(1,1)-Xstd)/Xstd
        if rand<abar^(v)
           s(j+v)=1;
        else
           s(j+v)=0;
        end      
    else
        if rand<abar^(v)
           s(j+v)=0;
        else
           s(j+v)=1;
        end 
    end
%based on the signal and the current value of epss generate probabilites
for i=j+1:j+v
    if      (epshat(j)==(Support(1,1)-Xstd)/Xstd & s(i)==1)
        
            PIprime2      = (PIsp)^(i-j);
            PR_x1_x(i)   =  PIprime2(1,1); PR_x2_x(i)   =  PIprime2(1,2);
            %The next line calculates the probability we are going to be in
            %state 1
            PR_x1_x_s(i) =     abar^(i-j)*PR_x1_x(i)/(abar^(i-j)*PR_x1_x(i)+(1-abar^(i-j))*PR_x2_x(i));  
            %The next line calculates the probability we are going to be in
            %state 2
            PR_x2_x_s(i) = (1-abar^(i-j))*PR_x2_x(i)/(abar^(i-j)*PR_x1_x(i)+(1-abar^(i-j))*PR_x2_x(i));  
            
    elseif  (epshat(j)==(Support(1,1)-Xstd)/Xstd & s(i)==0)
        
            PIprime2      = (PIsp)^(i-j);
            PR_x1_x(i)   =  PIprime2(1,1); PR_x2_x(i)   =  PIprime2(1,2);
            PR_x1_x_s(i) =   (1-abar^(i-j))*PR_x1_x(i)/((1-abar^(i-j))*PR_x1_x(i)+abar^(i-j)*PR_x2_x(i));
            PR_x2_x_s(i) =       abar^(i-j)*PR_x2_x(i)/((1-abar^(i-j))*PR_x1_x(i)+abar^(i-j)*PR_x2_x(i));   
            
    elseif  (epshat(j)==(Support(2,1)-Xstd)/Xstd & s(i)==1)

            PIprime2      = (PIsp)^(i-j);
            PR_x1_x(i)   =  PIprime2(2,1); PR_x2_x(i)   =  PIprime2(2,2);
            PR_x1_x_s(i) =     abar^(i-j)*PR_x1_x(i)/(abar^(i-j)*PR_x1_x(i)+(1-abar^(i-j))*PR_x2_x(i));
            PR_x2_x_s(i) = (1-abar^(i-j))*PR_x2_x(i)/(abar^(i-j)*PR_x1_x(i)+(1-abar^(i-j))*PR_x2_x(i));   
            
    elseif  (epshat(j)==(Support(2,1)-Xstd)/Xstd & s(i)==0)

            PIprime2      = (PIsp)^(i-j);
            PR_x1_x(i)   =  PIprime2(2,1); PR_x2_x(i)   =  PIprime2(2,2);
            PR_x1_x_s(i) =  (1-abar^(i-j))*PR_x1_x(i)/(abar^(i-j)*PR_x2_x(i)+(1-abar^(i-j))*PR_x1_x(i));
            PR_x2_x_s(i) =      abar^(i-j)*PR_x2_x(i)/(abar^(i-j)*PR_x2_x(i)+(1-abar^(i-j))*PR_x1_x(i));
    end
    epshat2(i)=(Support(1,1)-Xstd)/Xstd*PR_x1_x_s(i) + (Support(2,1)-Xstd)/Xstd*PR_x2_x_s(i);
end
%with probaiblity PR_x1_x_s(i) we are in state 1 and with probability
%PR_x2_x_s(i) we are in state 2.
for tt2 = j+v+1:j+T
    PIprime = (PIsp)^(tt2-(j+v));
    epshat2(tt2) = PR_x1_x_s(i)*((Support(1,1)-Xstd)/Xstd*PIprime(1,1)+...
                                  (Support(2,1)-Xstd)/Xstd*PIprime(1,2))+...
                   PR_x2_x_s(i)*((Support(1,1)-Xstd)/Xstd*PIprime(2,1)+...
                                  (Support(2,1)-Xstd)/Xstd*PIprime(2,2));          
end