periods= 2000;
var C, OMEGA, U, DELTA, H, M, Y, K, I, X, LAMBDA, MIU, PHIS,W,z;  //Endogenous variables; note that z in endogenous

varexo e;                                       //Exogenous variables, they must be iid

parameters alpha, beta, gamma, rho,SDP,Utilcoef,sigma,theta,GP,GDP,US,G1,gammai,xsi;      //Parameters
parameters alpha, beta, gamma, rho,SDP,Utilcoef,sigma,theta,GP,GDP,US,G1,gammai,xsi,TB_Y,Rval;
parameters Acoef,Axc,Kval1,Kval2,KStarget,YStarget,UStarget,HStarget,delta2,a1,a2 ;
parameters IStarget,CStarget,XStarget,Axc,BStarget,xsi1,xsi2,xsi3,PHIStarget,LAMBDAStarget;
parameters PHIS1,PHIS12,LAMBDAS1,LAMBDAS2,MIUStarget,XStarget,TBStarget,eta,eta2;
parameters aa1,aa2,v,bcoef,Utilcoef,Starget,ValueStarget,gammabeta,gammaq,V,k_co,Profitstarget,gamman,Drts,LStarget,MStarget;


%
alpha 	 = 0.64;
k_co     = 1-alpha;
beta  	 = 0.985;
gammabeta = beta;
gamma 	 = 0.001;
SDP   	 =1.3;
Utilcoef = .15; 
theta 	 = 1.4000;
gammai	 = SDP;
sigma  =1;
rho=1;//0.999999;
xsi      =  5.1755;
US       = 1;
delta2   = 0.0125; 

Drts=1;

delta2   = 0.0125;
UStarget=1;
HStarget=1/5;
LStarget=1;

Acoef=1-gamma;
Kval1=1/beta-(1-delta2);
Kval2=Drts*(1-alpha)*HStarget^(Drts*alpha)*LStarget^(1-Drts);
KStarget=(Kval1/Kval2)^(1/(Drts*(1-alpha)-1));
IStarget=KStarget*delta2;
YStarget=(KStarget^(1-alpha)*HStarget^alpha)^Drts*LStarget^(1-Drts);
WStarget=(alpha*Drts)*YStarget/HStarget;
CStarget=YStarget-IStarget;
XStarget=CStarget;
xsi1=theta*HStarget^(theta-1)*XStarget/WStarget;
xsi2=HStarget^theta*gamma;
xsi3=(1-beta*(1-gamma));
xsi=1/(xsi1+xsi2/xsi3);
MStarget=CStarget*(1-xsi*HStarget^theta);
PHIS1=MStarget^(-sigma)*xsi*HStarget^theta;
PHIS2=1-beta*(1-gamma);
PHIStarget=PHIS1/PHIS2;
LAMBDAS1=MStarget^(-sigma)*xsi*theta*HStarget^(theta-1)*XStarget;
LAMBDAS2=alpha*Drts*(YStarget/HStarget);
LAMBDAStarget=LAMBDAS1/LAMBDAS2;
MIUStarget=LAMBDAStarget;
GPUS     = (1-alpha)*Drts*YStarget/KStarget;
     GP = GPUS/UStarget;
     GDP=Utilcoef*GPUS/UStarget^2 %0.19
     G1=GP*UStarget;
     GDP*UStarget/GP
Profitstarget=(1-k_co-alpha)*YStarget;
//Starget=MStarget^(-sigma)*((1-alpha)*YStarget-IStarget);
//ValueStarget=1/MStarget^(-sigma)*1/(1-beta)*Starget;
model(linear);                                        //After the instruction model type the equilibrium conditions

//1) FOC C

MStarget^(-sigma)*(-sigma)*M-LAMBDAStarget*LAMBDA - gamma*PHIStarget*(PHIS+(gamma-1)*C+(1-gamma)*X(-1));

//2) FOC N
         
            -sigma*M+(theta-1)*H+X-(LAMBDA+Y-H);

              
//3) FOC U
                  
//4) Def delta
LAMBDA+Y-(1+Utilcoef)*U-MIU-K(-1);

delta2*DELTA-GP*U;
//5) RC
           //YStarget*Y  -  CStarget*C      - IStarget*(I-z);
YStarget*Y  -  CStarget*C      - IStarget*(I);
//6) Def M
              MStarget*M - CStarget*C + xsi*HStarget^theta*XStarget*(theta*H+X);  

//7) Def Y1

//Drts*((1-alpha)*U+ alpha*H+(1-alpha)*K(-1))-Y;

Drts*((1-alpha)*U+ z+alpha*H+(1-alpha)*K(-1))-Y;
           
//9) FOC K'
             
MIU - beta*(1-delta2)*MIU(+1) + beta*delta2*DELTA(+1)-beta*Drts*(1-alpha)*YStarget/KStarget*(LAMBDA(+1)+Y(+1)-K);
//10) FOC I
            

//-LAMBDA+z+MIU
-LAMBDA+MIU
+beta*SDP*OMEGA(+1)
-SDP*OMEGA;

I-I(-1)-OMEGA;
                                                                             
//11) K law of motion     

K - (1-delta2)*K(-1)  + delta2*DELTA - IStarget/KStarget*I;
 X - gamma*C - (1-gamma)*X(-1);

 PHIStarget*PHIS - beta*PHIStarget*(1-gamma)*(PHIS(+1)+gamma*C(+1)-gamma*X)
-MStarget^(-sigma)*xsi*HStarget^theta*(-sigma*M+theta*H);

//15) Firm Value

        W-Y+H ;
 z =  rho*z(-1)+e;
end;

initval;                        // initval defines either the initial conditions or the initial guesses to solve for steady state
C= 0;
U=0;
DELTA=0;
H=0;
Y=0;
K=0;
W=0;
I=0;
LAMBDA=0;
MIU=0;
PHIS=0;
M=0;
//Profits=log(Profitstarget);
X=0;
//Valuefirm=log(ValueStarget);
e=0;
z=0;
end;
steady (solve_algo = 2 )  ;
//check;
shocks;
    var e;
    periods 1:2  ;
    values 0.0      ;
var e;
    periods  3:3;
    values .01    ;
    var e;
    periods 4:1000;
    values 0.00;
end;

//check;
simul;